//------------------------------------------------------------------------------
// GUI and routines for TiledPreview
//
// (c) 2000, 2001, Jesco Topp & Andy Ford
//------------------------------------------------------------------------------
unit App_TiledPreview;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TDlg_TiledPreview = class(TForm)
    procedure ShowModal(const PreviewTexture : TBitmap); virtual;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    Texture : TBitmap;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Dlg_TiledPreview: TDlg_TiledPreview;

implementation

{$R *.dfm}

procedure TDlg_TiledPreview.ShowModal;
begin
  Texture := TBitmap.Create;

  Texture.Assign( PreviewTexture );  //make texture available for other procedures in this class

  inherited ShowModal;
end;

procedure TDlg_TiledPreview.FormShow(Sender: TObject);
var
  x, y       : integer;
begin
  x := 0;

  repeat
    y := 0; //Reset y-coordinate every new column
    repeat
      Canvas.Draw(x, y, Texture);
      y := y + Texture.Height;
    until (y > Height);
    x := x + Texture.Width;
  until(x > Width);

  //Texture.Free;
end;

procedure TDlg_TiledPreview.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Texture.Free;
end;

end.
