//------------------------------------------------------------------------------
// Contains additional classes:
//
//   TNameTable, TImportTable, TExportTable
//   TTextureList
//   THeaderException
//
// (c) 2000, 2001, Jesco Topp & Andy Ford
//------------------------------------------------------------------------------
unit UTPFF_Aux_Classes;

interface

uses Windows, SysUtils;

const
  Size = 511;        //511

//------------------------------------------------------------------------------
// Tables
type
  TNameTable = Class(TObject)
    ObjectName     : array of string;
    ObjectFlags    : array of DWORD;         //Size
    Count          : integer;
    Offset         : integer;
    constructor Create( Size : integer; FOffset : longint );
end;

type
  TImportTable = Class(TObject)
    ClassPackage         : array of string;
    ClassName            : array of string;
    ImportPackage        : array of string;     //Size div 4
    ImportPackage_ObjRef : array of DWORD;
    ObjectName           : array of string;
    Count                : integer;
    Offset               : integer;
    constructor Create( Size : integer; FOffset : longint );
end;

type
  TExportTable = Class(TObject)
    ExportClass          : array of string;
    ExportClass_ObjRef   : array of DWORD;
    Super                : array of string;
    Super_ObjRef         : array of DWORD;         //Size
    ExportPackage        : array of string;
    ExportPackage_ObjRef : array of DWORD;
    ObjectName           : array of string;
    ObjectFlags          : array of DWORD;
    SerialSize           : array of DWORD;
    SerialOffset         : array of DWORD;
    Count                : integer;
    Offset               : integer;
    constructor Create( Size : integer; FOffset : longint );
end;
//------------------------------------------------------------------------------
// TextureList
type
  TTextureList = Class(TObject)
    Name       : array of string;                //Size
    Group      : array of string;
    ETIndex    : array of DWORD;   // index into ExportTable
    Count      : integer;
    constructor Create( Size : integer );
end;

//------------------------------------------------------------------------------
// Exception handlers

type
  EHeaderTableException = Class(Exception)
  end;

//------------------------------------------------------------------------------

implementation

//------------------------------------------------------------------------------
// Initialise Table-Arrays

constructor TNameTable.Create;
begin
  SetLength( ObjectName, Size );
  SetLength( ObjectFlags, Size );

  Count := Size + 1;
  Offset := FOffset;
end;

constructor TImportTable.Create;
begin
  SetLength( ClassPackage, Size );
  SetLength( ClassName, Size );
  SetLength( ImportPackage, Size );
  SetLength( ImportPackage_ObjRef, Size );
  SetLength( ObjectName, Size );

  Count := Size + 1;
  Offset := FOffset;
end;

constructor TExportTable.Create;
begin
  SetLength( ExportClass, Size );
  SetLength( ExportClass_ObjRef, Size );
  SetLength( Super, Size );
  SetLength( Super_ObjRef, Size );
  SetLength( ExportPackage, Size );
  SetLength( ExportPackage_ObjRef, Size );
  SetLength( ObjectName, Size );
  SetLength( ObjectFlags, Size );
  SetLength( SerialSize, Size );
  SetLength( SerialOffset, Size );
  
  Count := Size + 1;
  Offset := FOffset;
end;

constructor TTextureList.Create;
begin
  SetLength( Name, Size );
  SetLength( Group, Size );
  SetLength( ETIndex, Size );
end;

//------------------------------------------------------------------------------
end.
